(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
   Affiche les informations sur les programmes excutables au format PE.    
                                                                            
 Vocabulaire :                                                              
 -------------                                                              
                                                                            
 PE = Portable Executable                                                   
 RVA = Relative Virtual Addresses                                           
Ĵ
  Version    Consultez le fichier 'UNITE\A-Lire.txt' pour comprendre      
    les caractres dbutant les lignes.                          
                                                                            
 04/10/2000 => Version 0.3.2                                                
    + Possibilit de modifier le texte des botes de dialogue               
 02/10/2000 => Version 0.3.1                                                
    ! Correctin de la lecture des dialogues (longueur paire/impaire)        
 01/10/2000 => Version 0.3                                                  
    + Type de ressources reconnues : image bitmap, bote de dialogue et     
      chanes de caractre                                                  
 26/09/2000 => Version 0.2                                                  
    + Le systme de lecture des ressources est implment : c'tait vraiment
      un truc balze : entte de niveau, entre, ressource; puis passage    
      vers un tampon retransform XMS ... Balze : Bonne nuit!              
 18/08/2000 => Version 0.0 (cration)                                       
*)

{ Options de compilation : }
{$A+: Utilise des adresses paire (plus rapide)                               }
{$B+: Optimise les valuations logiques                                      }
{$D-: N'insre pas d'informations pour le dboggage                          }
{$G+: Utilise les instructions du 286 (SHL/SHR/ENTER/LEAVE)                  }
{$I-: Ne teste pas les erreurs d'entre/sortie                               }
{$L-: Dsactive la production des symboles locaux (pas de dbogueur)         }
{$N-: N'utilise pas le co-processeur arithmtique                            }
{$Q-: Ne teste pas les erreurs de dbordement (Word(65535+1) par exemple)    }
{$R-: Ne teste pas les erreurs de domaine (Tableau, ex: EcrnTxt[4050])       }
{$S-: Ne teste pas le dbordement de la pile (8192 octets suffisent)         }
{$Y-: Ne gnre pas les symboles locaux (pour dbogueur)                     }
{$X+: Ne demande pas de variable pour stocker le rsultat d'une fonction     }

{$M 4096,0,65536}

{@@@@@@@@@@@@ DEBUG }
{-$DEFINE ImposeNomFich: Impose le nom de fichier (constante '_NomFich')     }
{-$DEFINE AffichePasInfoPE: N'affiche pas l'entte PE                        }
{-$DEFINE AffichePasRepert: N'affiche pas les rpertoires                    }
{-$DEFINE AffichePasSection: N'affiche pas les sections                      }
{-$DEFINE AffichePasRsrc: N'affiche pas les ressources (ou les diter)       }

{-$DEFINE AffichePasDetailRsrc: N'affiche pas les dtails des ressources     }
{-$DEFINE DebugRes: Debogue les ressources                                   }
{@@@@@@@@@@@@ DEBUG }

uses
  UnitePE,                   { Unit propre au programme : pas mal d'entte  }
                             { et de procdures ddies  PE                 }
  Dos,                       { Pour appeler le programme d'affichage         }
  PolicTxt,                  { Chargement d'une police de caractre Windows  }
  Convert,NomFLong,StopProg,Xms,Clavier,EcranTxt,GestFich,GestStrg,Tampon;

{$I Rom16x8.win : Police de caractre 8x8 pixels Windows }

const
  Version = '0.3.2';

{$IFDEF ImposeNomFich}
const
  _NomFich =
 { Bote de dialogue tendue }
{ 'E:\Image\ACDSee\ACDSee32.EXE'; {}
{ 'E:\Image\ACD Systems\ACDSee\ACDSee.EXE'; {}

  { Longueur du nom pas OK }
{  'C:\Windows\Explorer.EXE'; {}
{ 'E:\Utilitaire\Winzip\WZsepe32.EXE'; {}
{ 'E:\Video\QuickTime\QTinfo.EXE'; {}
{ 'E:\Video\MultiDec\MultiDec44fr.EXE'; {}
{ 'E:\Internet\GnuTella\GnuTella.EXE'; {}
{ 'E:\Internet\Ad Killer\AKiller.EXE'; {}
{ 'E:\Internet\IMesh\Unwise.EXE'; {}
{ 'E:\Internet\Mirc\Mirc32.EXE'; {}
 'E:\Image\Paint Shop Pro 7 BETA\psp.EXE'; {}
{ 'E:\Internet\ICQ\DBConvert.EXE'; {}
{ 'E:\Warez\Crack\HEdit\HEdit.EXE'; {}
{ 'E:\Musique\Sonique\sonique.EXE'; {}
{ 'C:\Windows\DirectCC.EXE'; {}
{  'c:\upload\commando\coman_mp.icd'; {}
{  'c:\windows\system\grid32.ocx'; {}

  { Fichier NE }
{  'c:\windows\system\bt848.drv'; {}
{  'c:\windows\system\gdi.exe'; {}
{$ENDIF}

type
  { Un niveau de ressource (Taille = 2 octets) }
  TypeRsrcEnteteNiveau = record
    NbrEntree: Word;         { Nombre d'entre dans ce niveau                }
  end;

  { Une entre de ressource : rpertoire ou ressource (Taille = 12 octets) }
  TypeRsrcUneEntree = record
    TypeRepert: Boolean;     { Rpertoire : TRUE / FALSE -> Ressource        }
    NomExiste: Boolean;      { L'offset du nom pointe vers un nom ou alors   }
                             { c'est un type de ressource ?                  }
    LongNom: Word;           { Longueur du nom                               }
    OfstNom: LongInt;        { Offset du nom                                 }
    Ofst: LongInt;           { Si c'est un sous-rpertoire : offset de       }
                             { l'en-tte du prochain niveau                  }
                             { Si c'est une ressource : Offset de l'entte   }
  end;                       { de la ressource                               }

  { Un ressource (Taille = 8 octets) }
  TypeRsrcUneRsrc = record
    OfstDonnee: LongInt;     { Offset des donnes (dans le fichier)          }
    TailleDonnee: LongInt;   { Taille des donnes                            }
  end;

  { Debut manquant de l'entte des images BMP }
  TypeDebutEnteteBmp = record
    Signature      : Word;    { Signature BMP = 'BM'= 424Dh                  }
    TailleFich     : LongInt; { Taille du fichier                            }
    Reserve        : LongInt; { Reserv -> toujours gal  00000000h         }
    DebutDonnee    : LongInt; { Position du fichier ou dbutent les donnes  }
                              { de l'image                                   }
  end;

  { Entte des images BMP }
  TypeFinEnteteBmp = record
    TailleEnTete   : LongInt; { Taille de l'en-tte en octets                }
    Larg           : LongInt; { Largeur de l'image (en pixel)                }
    Haut           : LongInt; { Hauteur de l'image (en pixel)                }
    NbrPlan        : Word;    { Nombre de plans utiliss (=1)                }
    BitsParPixel   : Word;    { Nombre de bits par pixels                    }
    Compression    : LongInt; { 0: aucune                                    }
                              { 1: Codage des rptitions RLE sur 8 bits     }
                              { 2: Codage des rptitions RLE sur 4 bits     }
                              { 3: Bitfields encoding (???)                  }
    TailleImage    : LongInt; { Taille de l'image en octets                  }
    LargDPI        : LongInt; { ??? picture with in pels per meter ???       }
    HautDPI        : LongInt; { ??? picture height in pels per meter ???     }
    NbrCoulUtile   : LongInt; { Nombre de couleurs utilises (si gale  0   }
                              { toutes les couleurs sont utilises)          }
    NbrCoulImportante:LongInt;{ Nombre de couleurs importantes (si gale  0 }
                              { toutes les couleurs sont importantes)        }
  end;

  { Entte PE d'une bote de dialogue }
  TypePE_EnteteBoiteDialog = record
    OptionDS: Word;
    OptionWS: Word;
  end;

  { Entte PE d'une bote de dialogue }
  TypePE_EnteteDialog = record
    Zero1,Zero2: Word;                 { = 0000h                             }
    TrucA: Word;               { ??? }
    X,Y: Word;                         { Coordonne X et Y                   }
    Larg,Haut: Word;                   { Dimensions de la bote de dialogue  }
    Zero3,Zero4: Word;                 { = 0000h                             }
    (*
      Nom : Format UNICODE; { Taille (en comptant le zro) arrondie  2 }
    *)
  end;

  TypePE_EnteteDlgControl = record
    OptionDS: Word;
    OptionWS: Word;
    Zero2: Word;
    Zero3: Word;
    X,Y: Word;
    Larg,Haut: Word;
    Index: Integer;                    { Si gal  -1 : pas d'index          }
    (*
      NomTypeControl: Format UNICODE; { Taille arrondie  2 (avec le $0000)  }
                                      { Rq: Si le premier mot vaut FFFFh,    }
                                      {     alors c'est un index.            }

      Nom : Format UNICODE;           { Taille arrondie  2 (avec le $0000)  }
    *)
  end;

const
  { Couleurs }
  CoulResSelect = 15+2*16;  { Ressource slectionne }
  CoulResRepos  =  7;  { Ressource au repos }

  { Ressource }
  TailleUnBlocRes = 5 { Ko };          { Taille d'un bloc de ressource : le  }
                                       { tampon est allou par bloc de 5 Ko  }
  NbrControlMax = 25;                  { Nombre de contrles maximum         }

  { Programme d'affichage des images BMP }
  NomProgAffiche = 'Affiche.exe';
                                       { Nom du programme pour affiche les   }
                                       { images au format BMP                }
  ParamProgAffiche = {'/i'}'';         { Paramtres  transmettre  ce       }
                                       { programme                           }

  { Caractre rejets dans la modification d'un texte }
  CaractRejete = [_F1.._F10,_PAGEHAUT,_PAGEBAS,_INSERT,_RETOUR];

var
  PosFichMax: LongInt;                 { Position maximale du fichier  ne   }
                                       { pas dpasser                        }
  LongTxtTmp: Word;                    { Longueur temporaire du chane de    }
                                       { caractre lue                       }

  { Liste de toutes les ressources }
  ListeRes: record
    { Tampon des entres et ressources }
    TailleTampon: LongInt;
    Handle: LongInt;

    { Tampon des noms }
    TailleTamponNom: LongInt;
    HandleNom: LongInt;
  end;

  { Contrle des botes de dialogue }
  PE_EnteteDlgControl: TypePE_EnteteDlgControl;

  ListeControl: record
    PosPremierControl: LongInt;
    PosFichControl: array[1..NbrControlMax-1] of LongInt;
                                       { Position dans le fichier des        }
                                       { diffrents contrles                }
    IndexControl: Word;                { Index du contrle courant           }
    NbrControl: Word;                  { Nombre total de contrle            }
  end;
  SauveLigneTxt: Array[0..159] of byte absolute SavEcrnTxt7;

  { Structure pour lire/crire dans le tampon des noms }
  CopieXmsNom: StructCopieXms;

  EnteteNiveau: Array[0..NbrNiveauMax-1] of TypeRsrcEnteteNiveau;
  PosListeRes: Array[0..NbrNiveauMax-1] of Word;
  UneEntree: TypeRsrcUneEntree;
  OfstNiveau: Array[0..NbrNiveauMax-1] of LongInt;
  SauvePosFichNiv: Array[0..NbrNiveauMax-1] of LongInt;
  UneRessource: TypeRsrcUneRsrc;       { Une ressource                       }
  TypeRessourceActuel: LongInt;        { Type actuel du rpertoire de        }
                                       { ressource explor (voir fonction    }
                                       { PE_NomTypeRessource)                }
  NomTypeResActuel: String;            { Nom du type de ressource actuel     }

  {==========================}
  NomFich: String;

  TmpTxt,SauveTxt: String;
  i: Byte;
  ch: char;
  TmpO: Byte;
  TmpM: Word;
  TmpL: LongInt;

  OfstRessource: LongInt;       { Offset des ressources (dans le fichier)    }

procedure PrepareFin; FAR; begin
  with ListeRes do begin
    { Si le tampon est allou : le libre }
    if Handle<>0 then begin
      RendMemXms (Handle);
      Handle := 0;
    end;

    { Si le tampon des noms est allou : le libre }
    if HandleNom<>0 then begin
      RendMemXms (HandleNom);
      HandleNom := 0;
    end;
  end;
end;

procedure TestErreurXms (txt: string); begin
  if ErreurXms=0 then exit;

  EcriTxc (-1,-1,'ERREUR XMS - Pressez une touche',14+4*16); LitTouche;

  InitModeTxt;
  EcriTcr ('Erreur lors de '+txt+' (n'+Hex8z(ErreurXms)+') :',12);
  Ecrit ('> '); EcriTc (TxtErreurXms,15); EcriTr ('.');
  SauteLigne;
  EcriTcr ('Info pour le deboggage :',13);
  with CopieXms do begin
    Ecrit ('Taille = '); EcriTncr (Taille,10);
    Ecrit ('SrcHdl = '); EcriTncr (SrcHdl,10);
    Ecrit ('SrcOfs = '); EcriTnc (SrcOfs,10);
    Ecrit (' ('); EcriTc (Hex16z(SrcOfs shr 16)+':'+Hex16z(SrcOfs and $FFFF),10); EcriTr (')');
    Ecrit ('DstHdl = '); EcriTncr (DstHdl,10);
    Ecrit ('DstOfs = '); EcriTnc (DstOfs,10);
    Ecrit (' ('); EcriTc (Hex16z(DstOfs shr 16)+':'+Hex16z(DstOfs and $FFFF),10); EcriTr (')');
    Ecrit ('Mmoire XMS libre = '); EcriTnc (MemXmsLibre,10); EcriTr (' Ko');
  end;
  SauteLigne;
  EcriTc ('--- Pressez une touche pour finir ---',15+2*16); LitTouche;
  EffaceLigneTxt;
  PrepareFin;
  Halt;
end;

procedure Fin;
const
  { Couleurs }
  CoulCadre = 11+3*16;         { du cadre }
  CoulTitre = 15+0*16;
  CoulInfo = 14+3*16;         { des informations }
  CoulHttp =  9+3*16;
begin
  PrepareFin;

  InitModeTxt;
  CoulTxt := CoulCadre;
   EcriTx (18,0,'ͻ');
  EcriTx (16,1,'ͼ             ͻ');
  EcriTx(16,2,'     '); EcriTc ('EDITE PE',CoulTitre); Ecrit ('    ');
  EcriTx (16,3,'   '); EcriTc ('version '+Version,CoulTitre);
  EcriTh (6-length(Version),' ');
  Ecrit ('');
  EcriTx (16,4,'ͻ             ͼ');
    EcriTx (18,5,'ͻ ͼ');    EcriTx (42,5,'ͻ');
          EcriTx (24,6,' '); EcriTx (34,6,'ͼ '); EcriTc ('Un programme de',CoulInfo); Ecrit (' ͻ');
          EcriTx (24,7,' ͼ      '); EcriTc ('Haypo',CoulTitre); Ecrit (' ');
          EcriTc ('(haypo@ifrance.com)',CoulHttp); Ecrit ('    ');
  EcriTx (0,8,'ͻ'); EcriTx (24,8,' ͻ       ');
  EcriTc ('http://www.haypo.fr.st/',CoulHttp); Ecrit ('     ');
  EcriTx (0,9,' '); EcriTc ('Supporte tous les',CoulInfo); Ecrit (' ͼ ');
  EcriTx (34,9,'ͼ');
  EcriTx (0,10,' '); EcriTc ('fichiers PE :',CoulInfo); Ecrit ('     ͼ');
  EcriTx (0,11,' '); EcriTc ('.exe, .dll, .ocx,',CoulInfo); Ecrit (' ');
  EcriTx (0,12,' '); EcriTc ('.cpl, .ax, ...',CoulInfo); Ecrit ('    ');
  EcriTx (0,13,'ͻ ͼ');
           EcriTx (10,14,' ');
  EcriTx (10,15,' '); EcriTx (24,15,'ͻ');
  EcriTx (10,16,' '); EcriTx (24,16,' ');
  EcriTc ('* Corrige l''attribut lecture seule, la section',CoulInfo); Ecrit ('    ');
  EcriTx (10,17,' ͼ   '); EcriTc ('contenant le point d''entr du code',CoulInfo); Ecrit ('              ');
  EcriTx (10,18,'ͻ '); EcriTc ('* Reconnait les ressources de type : bote de',CoulInfo); Ecrit ('     ');
              EcriTx (24,19,'   '); EcriTc ('dialogue, chanes de caractre, image bitmap.',CoulInfo); Ecrit ('   ');
              EcriTx (24,20,' '); EcriTc ('* Supporte les noms de fichier longs',CoulInfo); Ecrit ('              ');
              EcriTx (24,21,'ͼ');
  CoulTxt := 7+0*16;

  EcriTxc (-1,24,'--- Tapez une touche pour quitter : ',15); LitTouche;
  EffaceLigneTxt; PosYr (-1);
  Halt;
end;

procedure ExtraitPsp (var Parametre: string); assembler; asm
  push ds                    { Sauve DS (vaut mieux)                         }

  mov ah,62h                 { Fonction 62h : Lecture du PSP                 }
  int 21h                    { Appel l'interruption gnrale de DOS          }
  { Sortie : BX = Segment du PSP }

  mov ds,bx                  { DS:SI -> (Source) Pointe sur le PSP           }
  mov si,80h                 { SI = 80h -> Paramtres transmis               }
  les di,[Parametre]         { ES:DI -> (Destination) Pointe sur la variable }
  mov cx,128/4               { CX = Longueur  copier (128 octets = 32x4)    }
{ rep movsd } db 66h; rep movsw   { Effectue la copie en 32 bits             }

  pop ds                     { Recharge DS                                   }
end;

procedure TraitePsp (txt: String); begin
  { Des guillemets >"< ? Si oui, c'est le nom du fichier au format long }
  TmpO := Pos('"',txt);
  if TmpO<>0 then begin
    { Cherche le deuxime guillements. Si abscent, cesse le programme }
    TmpM := Pos('"',Copy(txt,TmpO+1,length(txt)-TmpO));
    if TmpM=0 then
      StopProgram ('lecture des paramtres','Veuillez entrer le nom long de l''image entre deux guillemets >"<');
    inc (TmpM,TmpO);

    { Sauve le nom de l'image }
    NomFich := Copy(txt,TmpO+1,TmpM-(TmpO+1));
  end else NomFich := txt;

  EnleveEspace (NomFich);
end;

procedure Init; var attr: byte; begin
  ProcAppeleeStop := PrepareFin;

  { Vrifie la prsence du driver XMS }
  VerifiePresenceXms;
  {$IFNDEF ImposeNomFich}
    ExtraitPsp (txt);

    { Lit le nom de l'image dans le PSP ou le demande }
    if txt='' then begin
      EffaceEcranTxt;
      EcriTcr ('Entrez le nom du programme excutable au format PE (Windows 32 bits)  analyser:',15);
      EcriThc (80*2,' ',14+1*16); PosYr (-2);

      NomFich := '';
      if LitTxt (NomFich,80*2,14+2*16,14+1*16)=FALSE then NomFich := '' else EnleveEspace (NomFich);

      { Echape : cassos }
      if NomFich='' then begin
        EcriTcr ('(interruption de l''utilisateur)',12+1*16);
        SauteLigne;
        SauteLigne;
        SauteLigne;
        Halt;
      end;
    end else TraitePsp (txt);
  {$ELSE}
    NomFich := _NomFich;
  {$ENDIF}

  { Convertit le nom du fichier si c'est un nom long }
  txt := NomFich;
  if NomFichEstLong(txt) then begin
    { Noms de fichier long supports ? }
    TestSupportNomFichLong;

    { Rpertoire existant ? }
    TmpTxt:= RepertoireNomFich (NomFich);
    RenvoieNomFichCourt (TmpTxt,txt);
    if txt='' then
      StopProgramInfo ('lecture du nom de fichier long','Rpertoire inexistant','Rpertoire: '''+TmpTxt+'''');

    { Fichier existant ? }
    txt := NomFich;
    RenvoieNomFichCourt (txt,NomFich);
    if NomFich='' then
      StopProgramInfo ('lecture du nom de fichier long','Fichier introuvable','Fichier: '''+txt+'''');
  end;

  { Lecture et changement de l'attribut lecture seule s'il est actif }
  TmpO := LitAttribut (NomFich,attr);
  if TmpO<>0 then
    StopProgramInfo ('la lecture des attributs',TxtErreurFich(TmpO),'Fichier: '''+NomFich+'''');

  if attr and _attrLecture=_attrLecture then begin
    Ecrit ('Enlve l''attribut lecture seule : ');
    attr := attr and byte(not _attrLecture);

    TmpO := ChangeAttribut (NomFich,attr);
    if TmpO<>0 then
      StopProgramInfo ('changement des attributs',TxtErreurFich(TmpO),'Fichier: '''+NomFich+'''');

    EcriTcr ('OK',15);
  end;

  { Ouvre le fichier }
  TestErreurFich (OuvreFichier (F,_LectureEcriture,NomFich,'exe'),'l''ouverture du fichier',NomFich);
end;

procedure AfficheInfoPE; begin
  EffaceEcranTxt;
  CoulTxt := 15+3*16;
  Ecrit ('[ Information sur le programme ''');
  EcriTc (NomFichSansRep(NomFich),14+3*16); EcriTr (''' ]');
  CoulTxt :=  7+0*16;
  SauteLigne;

  with PE_EntetePE do begin
    Ecrit ('Processeur recquis : '); EcriTcr (PE_NomCpuRecquis (CPU),10);
    Ecrit ('Nombre de sections : '); EcriTncr (NbrSection,10);
    Ecrit ('Heure-Date de cration : '); EcriTcr (Hex32(DateCreation),10);
    Ecrit ('Taille de l''en-tte optionnel : '); EcriTnc (TailleEnteteOptionnel,10);
    Ecrit (' octets ('); EcriTc (Hex32(TailleEnteteOptionnel),10); EcriTr (')');
    Ecrit ('Caractristiques : ');
    if Option<>0 then begin
      Ecrit ('(='); EcriTc (Hex32(Option),10); EcriTr (')');
      if Option shr 13 and 1=1 then EcriTcr ('-> C''est une DLL',15);
      if Option shr 8 and 1=1 then EcriTcr ('-> Programme 32 bits',15);
      if Option shr 1 and 1=1 then EcriTcr ('-> Excutable',10);
      if Option shr 9 and 1=1 then EcriTcr ('-> Ne contient pas d''information de dbogage',10);
      if Option shr 0 and 1=0 then EcriTcr ('-> Contient des informations rallouables',10);
      if Option shr 14 and 1=1 then EcriTcr ('-> Ne supporte pas les systmes multi-processeurs',12);
      if Option shr 10 and 1=1 then EcriTcr (
        '-> Ne doit pas tre lanc depuis un suport changeable (CD-Rom)',12);
      if Option shr 11 and 1=1 then EcriTcr ('-> Ne doit pas tre lanc depuis un rseau',12);
{      if Option shr 2 and 1=1 then EcriTcr ('-> ?-line number information is stripped-?',10); {}
      if Option shr 3 and 1=0 then EcriTcr ('-> Contient des informations sur les symboles locaux',10);
      if Option shr 4 and 1=1 then EcriTcr ('-> Le systme d''exploitation est cens ''trim the working ...''',10);
      if (Option shr 7 and 1=1) and (Option shr 15 and 1=1) then
        EcriTcr ('-> Les octets doivent tre changs mot/mot',10);
      if Option shr 12 and 1=1 then EcriTcr ('-> C''est un fichier systme (pilote)',10);
    end else EcriTcr ('aucune', 12);
  end;
  SauteLigne;
  EcriTc ('===> Pressez une touche pour voir les informations optionnelles : ',15+5*16);
  LitTouche;

  { Affiche les informations optionnelles }
  EffaceEcranTxt;
  with PE_EnteteOptionnelPE do begin
    EcriTcr ('[ RVA et tailles ]',15+3*16);
    Ecrit ('RVA Image Base = '); EcriTcr (Hex32z(RvaImageBase),10);
    Ecrit ('RVA PE du code = '); EcriTcr (Hex32z(RvaPointEntreeCode),10);
    Ecrit ('RVA Code       = '); EcriTc (Hex32z(RvaCode),10);
    Ecrit (', taille du code     = '); EcriTcr (Hex32z(TailleCode),10);
    Ecrit ('RVA Donne     = '); EcriTc (Hex32z(RvaDonnee),10);
    Ecrit (', taille des donnes = '); EcriTcr (Hex32z(TailleDonnee),10);
    Ecrit ('Taille des variables = ');
    if TailleVar<>0 then EcriTcr (Hex32z(TailleVar),10) else EcriTcr ('(nulle)',9);
    Ecrit ('Taille des en-ttes : '); EcriTnc (TailleDesEntete,10); EcriTr (' octets');
    SauteLigne;

    { Alignement }
    EcriTcr ('[ Alignement ]',15+3*16);
    Ecrit ('Alignement dans la mmoire = par '); EcriTnc (AlignementRam,10); EcriTr (' octets');
    Ecrit ('Alignement dans le fichier = par '); EcriTnc (AlignementFichier,10); EcriTr (' octets');
    SauteLigne;

    { Version de l'OS }
    EcriTcr ('[ Version de l''OS ]',15+3*16);
    Ecrit ('Version de l''OS (Windows) recquis = '); EcriTnc (VerMajOS,10); EcriTc ('.',10); EcriTncr (VerMinOS,10);
    Ecrit ('Version du binaire = '); EcriTnc (VerMaj,10); EcriTc ('.',10); EcriTncr (VerMin,10);
    Ecrit ('Version du sous-systme (Win32) recquis = '); EcriTnc (VerMajSousOS,10);
    EcriTc ('.',10); EcriTnc (VerMinSousOS,10);
    if ((VerMajSousOS=4) and (VerMinSousOS=0)) then EcriTr (' (Windows 95)') else SauteLigne;

    Ecrit ('Sous-systme recquis : '); EcriTcr (PE_NomSousSystem(SousSystemeRecquis),10);
    SauteLigne;
    EcriTc ('===> Pressez une touche pour voir les diffrents rpertoires : ',15+5*16);
    LitTouche;
  end;
end;

procedure AfficheRepertoire; begin with PE_EnteteOptionnelPE do begin
  { Affiche les 16 RVA et taille }
  EffaceEcranTxt;
  EcriTxcr (-1,0,'[ LES REPERTOIRES ]',15+3*16);
  PosY (5);
  for i := 1 to 16 do with Repertoire[i] do if (Rva<>0) and (Taille<>0) then begin
    Ecrit ('('); EcriTnc (i,10); Ecrit (') ');
    EcriTc (PE_NomRepertoire(i),15);
    PosX (35);
    Ecrit (': ');
    Ecrit ('RVA= '); EcriTc (Hex32z(RVA),10);
    Ecrit (' - Taille= '); EcriTnc (Taille,10); EcriTr (' octets');
  end;
  SauteLigne;
  EcriTxc (0,24,'===> Tapez une touche pour continuer : ',15+5*16);
  LitTouche;
end end;

function LitTailleVirtuelUneSection (PosDonnee,TailleDonnee: LongInt) : LongInt;
var SauvePosFich: LongInt;
begin
  { Est-ce que le nom de la section est 'BSS' ? }
  move (PE_EnteteSection.Nom,txt[1],8); txt[0] := #8; EnleveEspace (txt); ConvertitMajuscule (txt);
  if Pos('BSS',txt)<>0 then begin
    LitTailleVirtuelUneSection := {EnteteOptionnelPE.TailleVar}-1;
    Exit;
  end;

  { Pour l'instant la taille de la section est la taille entre }
  LitTailleVirtuelUneSection := TailleDonnee;

  { La taille des donnes est nulle ? }
  if TailleDonnee=0 then exit;

  { Sauve la position du fichier }
  SauvePosFich := FilePos(F);

  { Se positionne au dernier octet de la section }
  Seek (F, PosDonnee+TailleDonnee -1);
  BlockRead (F, TmpO, 1);
  while (TmpO=0) and (PosDonnee<FilePos(F)) do begin
    Seek (F, FilePos(F)-2);
    BlockRead (F, TmpO, 1);
  end;

  { Lit la taille }
  TmpL := FilePos(F)-PosDonnee;

  { Arrondi  4 par excs (format 32 bits) }
  if TmpL mod 4<>0 then LitTailleVirtuelUneSection := TmpL and (not 3) +4;

  { Repositionne le fichier  la position sauvegarde }
  Seek (F, SauvePosFich);
end;

procedure AfficheInfoUneSection; begin with PE_EnteteSection do begin
  Ecrit (' ');

  { Ecrit le nom }
  move (Nom,txt[1],8); txt[0] := #8; EnleveEspace (txt);
  EcriTc (txt,15); PosX (10); Ecrit (' ');

  { Ecrit la taille RVA }
  EcriTc (Hex32z(TailleVirtuelle),14) ;
  PosX (10+12); Ecrit (' ');

  { Ecrit l'offset RVA }
  EcriTc (Hex32z(RvaSectionTmp),14);
  inc (RvaSectionTmp,TailleVirtuelle);
  PosX (10+12+12); Ecrit (' ');

  { Ecrit la taille RAW }
  EcriTc (Hex32z(TailleDonnee),14);
  PosX (10+12+12+12); Ecrit (' ');

  { Ecrit l'offset RAW }
  if PosDonnee<>0 then EcriTc (Hex32z(PosDonnee),14) else EcriTc ('(pas dispo)',9);
  PosX (10+12+12+12+12); Ecrit (' ');

  { Ecrit les caractristiques }
  EcriTc (PE_NomCaracteristique(Option),9);
  PosX (79); Ecrit ('');
end end;

{ Cherche la section contenant le point d'entre. S'il est introuvable }
{ alors renvoie FALSE, sinon TRUE et 'EnteteSection' contient les      }
{ informations sur la section                                          }
function ChercheSectionCode (RvaPointEntree: LongInt; var NomSection: String) : Boolean;
var SauvePosFich: LongInt;
begin with PE_EnteteSection do begin
  { Pour l'instant l'offset est introuvable }
  ChercheSectionCode := FALSE;

  { Il y a-t-il au moins une section ? }
  if PE_EntetePE.NbrSection=0 then exit;

  { Sauvegarde la position du fichier }
  SauvePosFich := FilePos(F);

  { Initialise l'offset RVA des sections }
  RvaSectionTmp := PE_EnteteOptionnelPE.RvaCode;

  { Scanne toutes les sections  la recherche }
  { de celle nomme 'CODE' ou '.code'         }
  IndexSection := 1; txt := '';
  while IndexSection<PE_EntetePE.NbrSection+1 do begin
    PE_LitUneSection;

    { Est-ce que la section est excutable et lisible }
    if (RvaSectionTmp<=RvaPointEntree) and (RvaPointEntree<=RvaSectionTmp+TailleVirtuelle) then begin
      { Renvoie la position de la section }
      ChercheSectionCode := TRUE;

      { Renvoie le nom de la section }
      move (Nom,NomSection[1],8); NomSection[0] := #8;
      EnleveEspace (NomSection);

      { Revient  la position sauvegarde du fichier }
      Seek (F, SauvePosFich);
      Exit;
    end;

    inc (IndexSection);
    inc (RvaSectionTmp,TailleVirtuelle);
  end;

  { Revient  la position sauvegarde du fichier }
  Seek (F, SauvePosFich);
end end;

procedure LitPuisAfficheSections;
var SauvePosFich: LongInt;
begin with PE_EntetePE do begin
  EffaceEcranTxt;
  EcriTxcr (-1,EcranY,'= LES SECTIONS =',15);
  SauteLigne;

  if NbrSection=0 then begin
    EcriTcr ('Aucune section !',12);
    SauteLigne;
    Exit;
  end;

  { Initialise l'offset RVA des donnes }
  SauvePosFich := FilePos(F);
  RvaSectionTmp := PE_EnteteOptionnelPE.RvaCode;

  EcriTr ('Ŀ');
  EcriTr ('   Nom   Taille VirtOffset VirtTaille RAW Offset RAW   Caractristiques  ');
  EcriTr ('Ĵ');

  i := 0;
  repeat
    inc (i);
    PE_LitUneSection;
    AfficheInfoUneSection;
  until i=NbrSection;

  EcriTr ('');
  SauteLigne;

  with PE_EnteteOptionnelPE do begin
    Seek (F, SauvePosFich);
    if ChercheSectionCode (RvaPointEntreeCode,txt) then with PE_EnteteSection do begin
      TmpL := PosDonnee;
      TmpL := TmpL +RvaPointEntreeCode-RvaCode;
      Ecrit ('Offset du point d''entre dans le fichier = '); EcriTcr (Hex32z(TmpL),10);
      Ecrit ('Situ dans la section '''); EcriTc (txt,15); Ecrit (''' de caractristiques : ');
      EcriTc (PE_NomCaracteristique(Option),15);

      if Option and $20000020<>$20000020 then begin
        SauteLigne;
        SauteLigne;

        EcriTc ('Les caractristiques sont fausses, voulez-vous les corriger (O/N) ? ',15);
        ch := UpCase(LitTouche);
        EffaceLigneTxt;
        PosYr (+1); EffaceLigneTxt; PosYr (-1);

        if ch='O' then with PE_EnteteSection do begin
          { Met les caractristiques code }
          Option := $E0000020;
          BlockWrite (F, PE_EnteteSection, SizeOf(PE_EnteteSection));
          EcriTcr ('Section modifie !',12);
        end;
      end else EcriTcr (' (exact)',10);
    end else EcriTcr ('La section contenant le code est introuvable !',12);
  end;

  SauteLigne;
  LitTouche;
end end;

procedure VerifieTailleTampon (Hdl: Word; var TailleTampon: LongInt;
                               NouvOfst: LongInt);
begin
  { La taille du tampon est bonne : exit }
  if NouvOfst<TailleTampon then exit;

  { Tampon trop petit : l'agrandi }
  if MemXmsLibre<TailleUnBlocRes then
    StopProgram ('l''agrandissement du tampon des ressources','Mmoire libre insuffisante');
  inc (TailleTampon, TailleUnBlocRes);
  RedimBlocXms (Hdl, TailleTampon);
  TestErreurXms ('agrandissement d''un tampon');
end;

procedure CreeListeRessource;
var
  SauvePosFich: LongInt;
  ProchainOfstLibre: LongInt;
  OfstCourant: Array[0..NbrNiveauMax-1] of LongInt;
                                       { Offset courant d'un certain niveau  }
  IndexRes: array[0..NbrNiveauMax-1] of Word;
label
  NouveauNiveau,DescendNiveau;
begin with ListeRes do begin
  SauvePosFich := FilePos(F);

  { Initialise les donnes : Niveau=Root (0), Taille=0 }
  Niveau := 0;
  OfstCourant[Niveau] := 0;
  ProchainOfstLibre := 0;

  { Alloue les tampons }
  TmpL := TailleUnBlocRes;
  if MemXmsLibre<TmpL*2 then
    StopProgram ('l''allocation du tampon des ressources','Mmoire libre insuffisante');
  Handle := AlloueMemXms (TmpL);
  TestErreurXms ('l''allocation du tampon des ressources');
  HandleNom := AlloueMemXms (TmpL);
  TestErreurXms ('l''allocation du tampon des noms');

  with CopieXms do begin
    DstHdl := Handle;
    DstOfs := 0;
  end;

  with CopieXmsNom do begin
    DstHdl := HandleNom;
    SrcOfs := Ptr2Long( @txt[1] );
    DstOfs := 0;
  end;

NouveauNiveau:
  { ============ NOUVEAU NIVEAU ============= }

  { Lit l'entte du niveau (nombre d'entres) }
  IndexRes[Niveau] := 0;
  PE_LitEnteteRessource;

  { Ecrit l'entte niveau }
  with EnteteNiveau[Niveau] do with PE_EnteteRessource[Niveau] do
    NbrEntree := NbrEntreeNommee+NbrEntreeIndexee;

  with CopieXms do begin
    Taille := SizeOf(TypeRsrcEnteteNiveau);
    SrcOfs := Ptr2Long( @EnteteNiveau[Niveau] );
    DstOfs := ProchainOfstLibre;

    { Calcul l'offset des entres du niveau }
    inc (ProchainOfstLibre, Taille);
    OfstCourant[Niveau] := ProchainOfstLibre;

    { Calcul le prochain offset libre }
    inc (ProchainOfstLibre, EnteteNiveau[Niveau].NbrEntree*SizeOf(TypeRsrcUneEntree));

    { Est-ce que le tampon est trop petit ? Si c'est le cas l'agrandi }
    VerifieTailleTampon (Handle, TailleTampon, ProchainOfstLibre);
  end;
  CopieMemXms (CopieXms); TestErreurXms ('l''criture de l''entte niveau');

DescendNiveau:
  { Traite une entre aprs l'autre. Si un sous-rpertoire est trouv : }
  { rentre dedans ! }
  with PE_EnteteRessource[Niveau] do while IndexRes[Niveau]<NbrEntreeNommee+NbrEntreeIndexee do begin
    { ============ NOUVELLE ENTREE ============= }
    inc (IndexRes[Niveau]);

    PE_LitRepertoireRsrc;
    with PE_RepertoireRes do begin
      { Pour l'instant, on a un nom }
      UneEntree.NomExiste := TRUE;

      { Cre le nom }
      if Ofst shr 31<>0 then begin
        if Nom shr 31=0 then begin
        { Pas de nom, mais un index }
          UneEntree.NomExiste := FALSE;
          UneEntree.OfstNom := Nom;
        { Lit le nom dans le fichier }
        end else txt := PE_LitNomRessource (OfstRessource +Nom and $7FFFFFFF);
      end else begin
        UneEntree.NomExiste := FALSE;
        UneEntree.OfstNom := -Nom;
      end;

      { Si le nom existe : l'crit dans le tampon }
      if UneEntree.NomExiste then begin
        if 60<length(txt) then Delete (txt,60,length(txt)-60);
        UneEntree.LongNom := length(txt);

        { Ecrit le nom dans le tampon des noms }
        with CopieXmsNom do begin
          if length(txt) and 1=1 then txt[0] := chr( length(txt)+1 );
          Taille := length(txt);
        end;
        CopieMemXms (CopieXmsNom); TestErreurXms ('l''criture d''un nom de ressource');
      end;

      { Ecrit l'entre }
      with UneEntree do begin
        { Est-ce un rpertoire ou une ressource ? }
        TypeRepert := PE_RepertoireRes.Ofst shr 31=1;
        Ofst := ProchainOfstLibre;

        { Offset du nom }
        if NomExiste then with CopieXmsNom do begin
          OfstNom := DstOfs;
          inc (DstOfs, Taille);

          { Est-ce que le tampon des noms est trop petit ? }
          { Si c'est le cas : l'agrandi                    }
          VerifieTailleTampon (HandleNom, TailleTamponNom, DstOfs);
        end;
      end;
      with CopieXms do begin
        Taille := SizeOf(TypeRsrcUneEntree);
        SrcOfs := Ptr2Long( @UneEntree );
        DstOfs := OfstCourant[Niveau];

        { Ajoute la taille de l'entre  l'offset du niveau courant }
        inc (OfstCourant[Niveau],Taille);
      end;
      CopieMemXms (CopieXms); TestErreurXms ('l''criture d''une entre');

      { Est-ce un sous-rpertoire ? Si oui, monte d'un niveau }
      if Ofst shr 31=1 then begin
        { Rentre dans un rpertoire }
        SauvePosFichNiv[Niveau] := FilePos(F);
        TmpL := OfstRessource +Ofst and $7FFFFFFF;
        if FileSize(F)<TmpL then
          StopProgram ('l''entre dans un rpertoire','Offset invalide')
        else
          Seek (F, TmpL);

        { Change de niveau }
        inc (Niveau);
        goto NouveauNiveau;
      end;
    end;
  end;
  { ============ FIN DU NIVEAU ============= }

  { Le niveau courant est trait : redescent d'un niveau (si nous ne sommes }
  { pas dans le niveau ROOT)                                                }
  if Niveau<>0 then with PE_RepertoireRes do begin
    { Est-ce le bot (une ressource) }
    if Ofst shr 31=0 then begin
      { Lit une ressource }
      TmpL := OfstRessource +Ofst and $7FFFFFFF;
      if FileSize(F)<TmpL then
        StopProgram ('l''entre dans un rpertoire','Offset invalide')
      else
        Seek (F, TmpL);
      PE_LitEnteteUneRes;

      { Ecrit l'entre }
      with UneRessource do begin
        OfstDonnee := PE_EnteteUneRes.Ofst;
        TailleDonnee := PE_EnteteUneRes.Taille;
      end;
      with CopieXms do begin
        Taille := SizeOf(PE_TypeEnteteUneRes);
        SrcOfs := Ptr2Long( @PE_EnteteUneRes );
        DstOfs := ProchainOfstLibre;

        { Ajoute la taille de l'entte ressource au prochain offset libre }
        inc (ProchainOfstLibre, Taille);

        { Est-ce que le tampon est trop petit ? Si c'est le cas l'agrandi }
        VerifieTailleTampon (Handle, TailleTampon, ProchainOfstLibre);
      end;
      CopieMemXms (CopieXms); TestErreurXms ('l''criture d''une ressource');

      { La ressource est dsormais lue }
      Ofst := $FFFFFFFF;
    end;

    { Descend d'un niveau }
    dec (Niveau);
    Seek (F, SauvePosFichNiv[Niveau]);
    goto DescendNiveau;
  end;

  { Revient  la position sauve }
  Seek (F, SauvePosFich);
end end;

procedure ConvertitChaineCpp (var txt: String);
var
  ch: char;
  i: byte;
  LongTxt: Byte;
begin
  LongTxt := length(txt);
  i := 1;
  while i<=LongTxt do begin
    Case txt[i] of
    { Retour  la ligne }
    #10: begin txt[i] := '\'; ch := 'n' end;

    { Tabulation }
    #9: begin txt[i] := '\'; ch := 't' end;

    { E accent grave }
    '': txt[i] := '';

    else ch := #0;
    end;

    { Il y a un caractre  insrer ? Si oui l'insre }
    if ch<>#0 then begin
      txt := Copy(txt,1,i)+ch+Copy(txt,i+1,length(txt)-i);
      inc (i);
      inc (LongTxt);
    end;
    inc (i);
  end;
  txt[0] := chr(LongTxt);
end;

procedure ConvertitChaineDosEnCpp (var txt: String);
var
  i: byte;
  LongTxt: Byte;
begin
  LongTxt := length(txt);
  i := 1;
  while i<=LongTxt do begin
    Case txt[i] of
    { A : grave, circonflexe }
    '': txt[i] := '';
    '': txt[i] := '';

    { C cdille }
    '': txt[i] := '';

    { E : aigu, grave, puis circonflexe }
    '': txt[i] := '';
    '': txt[i] := '';
    '': txt[i] := '';

    { O circonflexe }
    '': txt[i] := '';

    { U : grave puis circonflexe }
    '': txt[i] := '';
    '': txt[i] := '';

    { I circonflexe }
    '': txt[i] := '';

    { Degr celcius }
    '': txt[i] := '';
    end;

    { Passe au caractre suivant }
    inc (i);
  end;
  txt[0] := chr(LongTxt);
end;

procedure AfficheResTxt;
var
  IndexTxt: Word;
  LongTxt: Byte;
  VraiLongTxt: Word;
  PosFichMax: LongInt;
  Tronquee: Boolean;
begin with UneRessource do begin
  { Change de police de caractre }
  ChangePolice16x8 (RomAsciiWin);

  PosFichMax := FilePos(F)+TailleDonnee;
  IndexTxt := -UneEntree.OfstNom;
  repeat
    { Lit une chane de caractre }
    PE_LitTxtUnicode (txt,TRUE,67,VraiLongTxt);
    if txt<>'' then begin
      Tronquee := length(txt)<>VraiLongTxt;

      { Convertit la chane C++ dans un le format DOS }
      ConvertitChaineCpp (txt);
      if 67<length(txt) then begin
        txt[0] := chr(67);
        Tronquee := TRUE;
      end;

      EcriTnc (IndexTxt,10); PosX (6);
      Ecrit ('>'); EcriTc (txt,15);
      if Tronquee then EcriTc ('(...)',12);
      EcriTr ('<');

      { Trop de chanes : EXIT }
      if EcranY=24 then begin
        EcriTc ('Trop de chanes de caractre ...',12);
        Exit;
      end;

      inc (IndexTxt);
    end;
  until PosFichMax <= FilePos(F);
end end;


procedure AfficheOptionDS (Options: Word); var i: byte; begin
  if Options<>0 then begin
    for i := 0 to 15 do if Options shr i and 1=1 then begin
      Case i of
       0: EcriTc ('DS_AbsAlign',10);
       1: EcriTc ('DS_SysModal',10);
       6: EcriTc ('DS_SetFont',10);
       7: EcriTc ('DS_ModalFrame',10);
       9: EcriTc ('DS_SetForeGround',10);
      10: EcriTc ('DS_Control',10);
      else begin
        { autre = inconnu }
        Ecrit ('bit #');
        EcriTnc (i,14);
      end end;
      Ecrit (' + ');
    end;
    PosXr (-3); Ecrit ('   '); PosXr (-3);
    SauteLigne;
  end else EcriTcr ('(aucune)',12);
end;

procedure AfficheOptionWS (Options: Word); var i: byte; begin
  if Options<>0 then begin
    for i := 15 downto 0 do if Options shr i and 1=1 then begin
      Case i of
       1: EcriTc ('WS_Group',10);
{       3: EcriTc ('WS_SysMenu',10);}
       7: EcriTc ('WS_Caption',10);
      10: EcriTc ('WS_ClipSiblings',10);
      11: EcriTc ('WS_Disable',10);
      12: EcriTc ('WS_Visible',10);
      14: EcriTc ('WS_Child',10);
      15: EcriTc ('WS_PopUp',10);
      else begin
        { autre = inconnu }
        Ecrit ('bit #');
        EcriTnc (i,14);
      end end;
      Ecrit (' + ');
    end;
    PosXr (-3); Ecrit ('   '); PosXr (-3);
    SauteLigne;
  end else EcriTcr ('(aucune)',12);
end;

procedure AfficheOptionControlDS (Options: Word); var i: byte; begin
EcriTc (Bin16(Options),15); Ecrit (' ');
  if Options<>0 then begin
EcriTnc (Options and 7,10); Ecrit (' ');
    Case Options and 7 of
    1: EcriTc ('BS_AutoRadioButton',10);
    3: EcriTc ('BS_AutoCheckBox',10);
    7: EcriTc ('BS_GroupBox',10);
    else begin
      EcriTc ('inconnu=',14+4*16);
      EcriTnc (Options and 7,14);
    end end;
    Ecrit (' + ');

    for i := 4 to 15 do if Options shr i and 1=1 then begin
      Case i of
       7: EcriTc ('ES_Left',10);
      else begin
        { autre = inconnu }
        Ecrit ('bit #');
        EcriTnc (i,14);
      end end;
      Ecrit (' + ');
    end;
    PosXr (-3); Ecrit ('   '); PosXr (-3);
    SauteLigne;
  end else EcriTcr ('(aucune)',12);
end;

procedure AfficheOptionControlWS (Options: Word); var i: byte; begin
EcriTc (Bin16(Options),15); Ecrit (' ');
  if Options<>0 then begin
    for i := 15 downto 0 do if Options shr i and 1=1 then begin
      Case i of
       1: EcriTc ('WS_Group',10);
{       3: EcriTc ('WS_SysMenu',10);}
       7: EcriTc ('WS_Caption',10);
      10: EcriTc ('WS_ClipSiblings',10);
      11: EcriTc ('WS_Disable',10);
      12: EcriTc ('WS_Visible',10);
      14: EcriTc ('WS_Child',10);
      15: EcriTc ('WS_PopUp',10);
      else begin
        { autre = inconnu }
        Ecrit ('bit #');
        EcriTnc (i,14);
      end end;
      Ecrit (' + ');
    end;
    PosXr (-3); Ecrit ('   '); PosXr (-3);
    SauteLigne;
  end else EcriTcr ('(aucune)',12);
end;

procedure DeplaceControlDlg (Plus: ShortInt); begin with ListeControl do begin
  if Plus=-127 then TmpL := 0
  else if Plus=+127 then TmpL := NbrControl
  else begin
    { Se dplace relativement }
    TmpL := IndexControl +Plus;
    if TmpL<0 then TmpL := 0;
    if NbrControl<TmpL then TmpL := NbrControl;
  end;

  { Remet l'ancienne ligne de texte }
  AttendEcran;
  move (SauveLigneTxt,EcrnTxt[(1+IndexControl)*160],160);

  { Change de control }
  IndexControl := TmpL;

  { Sauve la ligne de texte, puis la colorie }
  move (EcrnTxt[(1+IndexControl)*160],SauveLigneTxt,160);
  ColoriH (0,1+IndexControl,80,CoulResSelect);
end end;

procedure AfficheTousControl;
var
  IndexControl: Word;
  LitUnMotNul: Boolean;
  Tronque: Boolean;
begin
  { Efface l'cran }
  EffaceEcranTxt;
  EcriTcr ('[ Les contles : numro) index, type, nom, coordonnes, dimensions ]',15+3*16);
  Seek (F, ListeControl.PosPremierControl);

  { Affiche un contrle aprs l'autre }
  IndexControl := 0;
  while (FilePos(F)<PosFichMax) and ({@@@@@@@@@@@@}
   EcranY<24)
   do begin
    { On dpasse de l'cran, attend une touche puis efface l'cran }
    if EcranY=24 then begin
      EcriTc ('*** Pressez une touche pour afficher la suite : ',15+5*16);
      CurseurOn; LitTouche;
      EffaceEcranTxt;
      EcriTcr ('[ Les contles : numro) index, type, nom, coordonnes, dimensions ]',15+3*16);
    end;

    { Lit un contrle }
    if IndexControl<>0 then ListeControl.PosFichControl[IndexControl] := FilePos(F);
    BlockRead (F, PE_EnteteDlgControl, SizeOf(PE_EnteteDlgControl));
    with PE_EnteteDlgControl do begin
      { Ecrit l'index du contle }
      EcriTnc (1+IndexControl,15); Ecrit (') ');

      { Ecrit l'index }
      if Index<>-1 then EcriTnc (Index,14) else EcriTc ('()',9);
      Ecrit (', ');

      { Lit puis affiche le type }
      LitUnMotNul := FALSE;
      if PE_LitTxtUnicode (txt,FALSE,-1,LongTxtTmp) then begin
      { Type nomm }
        Ecrit ('''');
        EcriTc (txt,14);
        Ecrit ('''');
        LitUnMotNul := LongTxtTmp and 1=0;
      end else if LongTxtTmp<>$FFFF then
      { Type index }
        PE_AfficheTypeControl (LongTxtTmp)
      { Type indfini }
      else EcriTc ('()',9);
      Ecrit (', ');

      { Lit et affiche le nom }
      if PE_LitTxtUnicode (txt,FALSE,40-3,LongTxtTmp) then begin
        LitUnMotNul := LitUnMotNul xor (LongTxtTMP and 1=0);
        Tronque := length(txt)<>LongTxtTMP;
        if txt<>'' then begin
          { Convertit la chane C++ dans un le format DOS }
          ConvertitChaineCpp (txt);
          if 40-3<length(txt) then begin
            txt[0] := chr(40-3);
            Tronque := TRUE;
          end;

          Ecrit ('''');
          EcriTc (txt,15);
          if Tronque then EcriTc ('...',12);
          Ecrit ('''');
        end else EcriTc ('()',9);
      end else begin
        LitUnMotNul := FALSE;
        EcriTnc (LongTxtTmp,15);
      end;

      Ecrit (', ');

      { Affiche les coordonnes et les dimensions }
      EcriTnc (X,10); Ecrit (','); EcriTnc (Y,10);
      Ecrit (' - '); EcriTnc (Larg,10); Ecrit (' x '); EcriTnc (Haut,10);

      { Affiche les options }
{      Ecrit ('Options DS : '); AfficheOptionControlDS (OptionDS);
      Ecrit ('Options WS : '); AfficheOptionControlWS (OptionWS);}

      { Debug }
      if Zero2<>0 then begin
        Ecrit (' Zero2 = ');
        EcriTc (Hex16(Zero2),14+4*16);
      end;
      if Zero3<>0 then begin
        Ecrit (' Zero3 = ');
        EcriTc (Hex16(Zero3),14+4*16);
      end;

      { Si le nom a une longueur impaire, lit un mot nul }
      if LitUnMotNul then begin
        BlockRead (F, TmpM, 2);
        if TmpM<>$0000 then begin
          Ecrit (' ZeroNom2 = ');
          EcriTcr (Hex16(TmpM),14+4*16);
        end;
      end;
    end;

    { Lit un mot nul (= $0000) }
    if FilePos(F)<>PosFichMax then begin
      BlockRead (F, TmpM, 2);
      if TmpM<>$0000 then begin
        Ecrit ('Dernier zro = ');
        EcriTcr (Hex16(TmpM),14+4*16);
      end;
    end;
    inc (IndexControl);
    SauteLigne;
  end;

  { Sauve le nombre de contrles }
  ListeControl.NbrControl := IndexControl-1;
  if NbrControlMax<ListeControl.NbrControl then ListeControl.NbrControl := NbrControlMax;

  { Slctionne le bon contrle }
  move (EcrnTxt[(1+ListeControl.IndexControl)*160],SauveLigneTxt,160);
  ColoriH (0,1+ListeControl.IndexControl,80,CoulResSelect);
end;

procedure PE_EcritTxtUnicode (EcritLongTxt: Boolean; txt: String); begin
  { Convertit la chane au format C++ }
  ConvertitChaineDosEnCpp (txt);

  { Ecrit la longueur de texte (si demand) }
  if EcritLongTxt then begin
    Seek (F, FilePos(F) +2);
    TmpM := length(txt);
    BlockWrite (F, TmpM, 2);
  end;

  { Ecrit les diffrents caractres }
  for i := 1 to length(txt) do begin
    TmpM := ord(txt[i]);
    BlockWrite (F, TmpM, 2);
  end;

  { Ecrit le caractre terminal : 0000h (si on n'a pas crit la longueur) }
  if EcritLongTxt=FALSE then begin
    TmpM := $0000;
    BlockWrite (F, TmpM, 2);
  end;
end;

function EditeTxt (var txt: String; LongMax: Byte; CouleurTxt,CoulTxtModifie: Byte) : Boolean;
var
  PosChr: Byte;                   { Position courante du caractre dans la   }
                                  { chane                                   }
  i: Byte;                        { Boucle                                   }
  ch: Char;                       { Lecture d'une touche au clavier          }
  TmpM: Word;                     { Mot temporaire                           }
  SauveCoulTxt: Byte;             { Sauve la couleur du texte                }
label Exit;
begin
  { Pour l'instant le texte a t captur avec succs }
  EditeTxt := TRUE;

  { Change la couleur du texte }
  SauveCoulTxt := CoulTxt;
  CoulTxt := CouleurTxt;
  PosChr := 1;

  { Ecrit le texte initial }
  SauvePosCurTxt;
  EcriTc (txt,CoulTxt);
  RemetPosCurTxt;

  repeat
    ch := LitTouche;
    Case ch of
    { Echape : On sort en renvoyant une chane vide }
    _ECHAPE: begin
      txt := '';
      EditeTxt := FALSE;
      Goto Exit;
    end;

    { Droite : Avance d'un caractre }
    _DROITE: if PosChr-1<length(txt) then begin
      inc (PosChr);
      PosXr (+1);
    end;

    { Gauche : Avance d'un caractre }
    _GAUCHE: if 1<PosChr then begin
      dec (PosChr);
      PosXr (-1);
    end;

    { Haut : Revient de 80 caractres }
    _HAUT: if 80<PosChr then begin
      dec (PosChr,80);
      PosXr (-80);
    end;

    { Bas : Avance de 80 caractres }
    _BAS: if (0<length(txt)) and (PosChr-1<>length(txt)) then begin
      TmpM := PosChr +80;
      if length(txt)+1<TmpM then TmpM := length(txt)+1;
      PosChr := TmpM;
      RemetPosCurTxt; PosXr (PosChr-1);
    end;

    { Suppression : remet l'ancien caractre }
    _SUPPR: begin
      txt[PosChr] := SauveTxt[PosChr];
      Ecrit (txt[PosChr]);
      PosXr (-1);
    end;

    { Dbut : Retour au dbut du texte }
    _DEBUT: begin
      RemetPosCurTxt;
      PosChr := 1;
    end;

    { Dbut : Retour au dbut du texte }
    _FIN: begin
      PosChr := length(txt)+1;
      RemetPosCurTxt; PosXr (length(txt));
    end;

    { Autre touche (hors Entre) : L'ajoute  la chane }
    else if (ch in CaractRejete)=FALSE then begin
    { Mode remplacement }
      { Si la touche Entre est press, ecrit le caractre retour  la ligne }
      if ch=_ENTREE then ch := #10;

      { Ecrit le caractre si on n'est pas  la fin du texte }
      if PosChr<=length(txt) then begin
        { Remplace un caractre }
        txt[PosChr] := ch;

        { Affiche le caractre remplac }
        if txt[PosChr]=SauveTxt[PosChr] then
          Ecrit (ch)
        else
          EcriTc (ch,CoulTxtModifie);

        { Passe au caractre suivant }
        inc (PosChr);
      end;
    end end;
  until (ch=_F5) or (ch=_F9);

  { F5 : tronque le texte }
  if ch=_F5 then begin
    for i := PosChr to length(txt) do EcriTc (txt[i],8+3*16);
    txt[0] := chr(PosChr-1);
  end;


Exit:
  { Remet l'ancienne couleur du texte }
  CoulTxt := SauveCoulTxt;

  { Positionne le curseur aprs la longueur maximale, puis va  la ligne }
  RemetPosCurTxt; PosXr (LongMax);
  if EcranX<>0 then SauteLigne;
end;

procedure EditeControl;
var
  TmpB: Boolean;
  PosFichTxt: LongInt;
begin
  EffaceEcranTxt;

  { Lit le contrle }
  with ListeControl do Seek (F, PosFichControl[IndexControl]);
  BlockRead (F, PE_EnteteDlgControl, SizeOf(PE_EnteteDlgControl));

  { Affiche le contrle }
  with PE_EnteteDlgControl do begin
    { Ecrit l'index du contle }
    Ecrit ('Numro du contrle = '); EcriTncr (1+ListeControl.IndexControl,15);

    { Ecrit l'index }
    Ecrit ('Index = '); if Index<>-1 then EcriTncr (Index,14) else EcriTcr ('()',9);

    { Affiche les coordonnes et les dimensions }
    Ecrit ('Coordonnes = '); EcriTnc (X,10); Ecrit (','); EcriTncr (Y,10);
    Ecrit ('Dimensions  = '); EcriTnc (Larg,10); Ecrit (' x '); EcriTncr (Haut,10);

    { Affiche les options }
{    Ecrit ('Options DS : '); AfficheOptionControlDS (OptionDS);
    Ecrit ('Options WS : '); AfficheOptionControlWS (OptionWS);}

    { Lit puis affiche le type }
    Ecrit ('Type de contrle = ');
    if PE_LitTxtUnicode (txt,FALSE,-1,LongTxtTmp) then begin
    { Type nomm }
      Ecrit ('''');
      EcriTc (txt,14);
      Ecrit ('''');
    end else if LongTxtTmp<>$FFFF then
    { Type index }
      PE_AfficheTypeControl (LongTxtTmp)
    { Type indfini }
    else EcriTc ('()',9);
    SauteLigne;
    SauteLigne;

    { Lit et affiche le nom }
    PosFichTxt := FilePos(F);
    TmpB := PE_LitTxtUnicode (txt,FALSE,-1,LongTxtTmp);
    SauveTxt := txt;

    { Affiche le texte prsentant le nom du contle }
    Ecrit ('Nom ');
    if TmpB then EcriTc ('(texte)',9) else EcriTc ('(index)',9);
    EcriTr (' = ');
    if TmpB and (txt<>'') then begin
      EcriTc ('=> Vous pouvez modifer le texte, mais il est ',14);
      EcriTcr ('INTERDIT DE CHANGER LA LONGUEUR !',12);
      EcriTcr ('=> Utilisez la touche SUPPR pour remettre un ancien caractre.',14);
      EcriTcr ('=> Vous pouvez utiliser les touches Tabulation (caractre '''+#9+''') et Entre ('''+#10+''').',14);
      EcriTcr ('=> Tapez la touche F10 pour confirmer, ou Echape pour quitter.',14);
      SauteLigne;
      Writeln (length(txt));
    end;

    { Affiche le nom }
    CurseurOn;
    if TmpB then begin
      if txt<>'' then begin
        { Modifie le texte }
        TmpM := length(txt);
        TmpB := EditeTxt (txt,TmpM,15+2*16,14+1*16);

        { Si l'utilisateur n'a pas quitt l'dition du texte : crit la modif}
        if TmpB and (txt<>SauveTxt) then begin
          SauteLigne;
          EcriTc ('Voulez-vous vraiment changer ce texte (O/N) ? ',15);
          if UpCase(LitTouche)='O' then begin
            EffaceLigneTxt;

            Seek (F, PosFichTxt);
            PE_EcritTxtUnicode (FALSE,txt);

            EcriTcr ('Le texte a t modifi dans le fichier !',15+1*16);
            LitTouche;
          end;
        end;
      end else begin
        EcriTcr ('()',9);
        LitTouche;
      end;
    end else begin
      EcriTncr (LongTxtTmp,15);
      LitTouche;
    end;

    { Debug }
    if Zero2<>0 then begin
      Ecrit (' Zero2 = ');
      EcriTc (Hex16(Zero2),14+4*16);
    end;
    if Zero3<>0 then begin
      Ecrit (' Zero3 = ');
      EcriTc (Hex16(Zero3),14+4*16);
    end;
  end;
end;

procedure AfficheResDlg;
var
  PE_EnteteBoiteDialog: TypePE_EnteteBoiteDialog;
  PE_EnteteDialog: TypePE_EnteteDialog;
  TxtTronque: Boolean;
  LongTxtTMP: Word;
  TmpM2: Word;
  LitUnMotNul: Boolean;
  SauvePosFich: LongInt;
begin with UneRessource do with ListeControl do begin
  { Calcule la position maximale du fichier }
  PosFichMax := FilePos(F)+TailleDonnee;

  { Change de police de caractre }
  ChangePolice16x8 (RomAsciiWin);

  { Lit l'en-tte }
  BlockRead (F, PE_EnteteBoiteDialog, SizeOF(PE_EnteteBoiteDialog));

  { Affiche les informations }
  with PE_EnteteBoiteDialog do begin
    { Lit puis affiche les informations sur la bote de dialogue }
    BlockRead (F, PE_EnteteDialog, SizeOF(PE_EnteteDialog));
    with PE_EnteteDialog do begin
      { Affiche les options (DS et WS) }
{      Ecrit ('Options DS : '); AfficheOptionDS (OptionDS);
      Ecrit ('Options WS : '); AfficheOptionWS (OptionWS); {}

      { Est-ce une bote de dialogue tendue ? }
      if {(OptionDS=$0001) and }(OptionWS=$FFFF) then begin
        EcriTcr ('Cette bote de dialogue est un format tendu (DialogEX),',12);
        EcriTcr ('et ce format n''est pas encore support.',12);
        SauteLigne;
        CurseurOn; LitTouche;
        Exit;
      end;

      { Affiche le nom }
      PE_LitTxtUnicode (txt,FALSE,60,LongTxtTMP);
      if txt<>'' then begin
        EcriTc (txt,15+1*16);
        if length(txt)<>LongTxtTMP then EcriTc ('...',12);
      end else EcriTc ('(pas de nom)',9);
      LitUnMotNul := LongTxtTmp and 1=0;

      Ecrit (' ');

      { Affiche la position puis les dimensions }
      EcriTnc (X,10); Ecrit (','); EcriTnc (Y,10);
      Ecrit (' - '); EcriTnc (Larg,10); Ecrit (',');
      EcriTnc (Haut,10);

      Ecrit ('   ---TrucA='); EcriTncR (TrucA,12);{ Ecrit (' -> '); EcriTc (Bin16(TrucA),15);
      Write (' -> ');
      for i := 0 to 15 do if TrucA shr i and 1=1 then Write ('bit #',i,', ');
      Writeln;}

      { Affiche (si utilise) la police de caractre }
      if PE_EnteteBoiteDialog.OptionDS shr 6 and 1=1 then begin
        { Lit la taille de la police }
        BlockRead (F, TmpM, 2);

        { Lit le nom de la police }
        PE_LitTxtUnicode (txt,FALSE,60,LongTxtTMP);
        LitUnMotNul := LitUnMotNul xor (LongTxtTMP and 1=0);

        { Puis affiche l'ensemble }
        Ecrit ('Police = '''); EcriTc (txt,14);
        if length(txt)<>LongTxtTmp then EcriTc ('...',12);
        Ecrit (''', ');
        Ecrit ('taille '); EcriTncr (TmpM,10);
      end;

      { Debug }
      if Zero1<>0 then begin
        Ecrit (' Zero1 = ');
        EcriTncr (Zero1,14+4*16);
      end;
      if Zero2<>0 then begin
        Ecrit (' Zero2 = ');
        EcriTncr (Zero2,14+4*16);
      end;
      if Zero3<>0 then begin
        Ecrit (' Zero3 = ');
        EcriTncr (Zero3,14+4*16);
      end;
      if Zero4<>0 then begin
        Ecrit (' Zero4 = ');
        EcriTncr (Zero4,14+4*16);
      end;

      { Si le nom a une longueur impaire, lit un mot nul }
      if LitUnMotNul then begin
        BlockRead (F, TmpM, 2);
        if TmpM<>$0000 then begin
          Ecrit (' ZeroNom1 = ');
          EcriTcr (Hex16(TmpM),14+4*16);
        end;
      end;
    end;
  end;
  SauteLigne;
  SauteLigne;
  EcriTc ('Tapez une touche pour afficher les contrles : ',15+5*16);
  CurseurOn; LitTouche;
  EffaceEcranTxt; CurseurOff;

  { Lit puis affiche tous les contrles }
  if PosFichMax<=FilePos(F) then begin
    EcriTcr ('(aucun contle)',10);
    LitTouche;
    Exit;
  end;

  { Affiche tous les contrles }
  IndexControl := 0;
  PosPremierControl := FilePos(F);
  AfficheTousControl;

  { Boucle d'dition des contrles }
  repeat
    ch := LitTouche;
    Case ch of
    _Debut: DeplaceControlDlg (-127);
    _Haut: DeplaceControlDlg (-1);
    _Bas: DeplaceControlDlg (+1);
    _Fin: DeplaceControlDlg (+127);
    _Entree: begin
      EditeControl;
      AfficheTousControl;
    end end;
  until ch=_ECHAPE;
  ch := #0;
end end;

procedure AfficheResHex;
var
  Index,IndexMax: LongInt;
  ix: byte;
begin with UneRessource do begin
  { Affiche les donnes }
  if 25*24<TailleDonnee then IndexMax := 25*24 else IndexMax := TailleDonnee;

  BlockRead (F, TamponOct, IndexMax);
  Index := 0; ix := 0;
  while Index<IndexMax do begin
    txt := Hex8z (TamponOct[index]); txt[0] := #2;
    Write (txt);

    { Fin de la ligne : affiche l'quivalant en ASCII }
    if 24-1=ix then begin
      PosX (80-24 -2);
      EcriTc (' ',15);
      for i := 0 to 24-1 do begin
        TmpO := TamponOct[index-ix +i];
        if TmpO=0 then EcriTc (' ',1*16)
        else if TmpO<32 then EcriTc ('.',8)
        else if TmpO=32 then EcriTc (' ',2*16)
        else if TmpO=255 then EcriTc (' ',3*16)
        else EcriTc (chr(TmpO),14);
      end;

      { Nouvelle ligne }
      ix := 0;
      if EcranY and 1=1 then begin
        EcriThc (80,' ',15+1*16);
        PosYr (-1);
      end;
    end else begin
      if ix mod 8=7 then Write (' - ');
      inc (ix);
    end;

    { Passe  l'octet suivant }
    inc (Index);
  end;

  { Fin de la ligne : affiche l'quivalant en ASCII }
  if 0<ix then begin
    PosX (80-24 -2);
    EcriTc (' ',15);
    for i := 0 to ix-1 do begin
      TmpO := TamponOct[index-ix +i];
      if TmpO<32 then EcriTc ('.',8)
      else if TmpO=32 then EcriTc (' ',1*16)
      else EcriTc (chr(TmpO),14);
    end;
    EcriThc (80-EcranX,' ',14+4*16);
  end;
end end;

procedure AfficheResBmp;
const
  NomFichTmp = 'temp.bmp';
var
  PosFich: LongInt;
  FichTmp: File;

  Bpp: Byte;
  TailleTampon: Word;
  DebutEnteteBmp : TypeDebutEnteteBmp;
  FinEnteteBmp   : TypeFinEnteteBmp;
  CodeSortie: Byte;
  Erreur: Word;
begin with UneRessource do begin
  { Cre le nom de fichier : rpertoire courant + nom (constante) }
  GetDir (0, txt);
  if txt[length(txt)]<>'\' then txt := txt+'\';
  txt := txt+NomFichTmp;

  { Le fichier existe dj ? Si oui l'efface }
  if FichierExistant (txt) then
    TestErreurFich (EffaceFichier (txt), 'effacement du fichier temporaire', txt);

  { Cre le fichier }
  TestErreurFich (CreeFichier (FichTmp, txt), 'cration d''un fichier temporaire', txt);

  { Lit l'entte }
  BlockRead (F, FinEnteteBmp, SizeOf(FinEnteteBmp));
  PosFich := SizeOf(FinEnteteBmp);

  { Ecrit le dbut de l'entte manquant }
  with DebutEnteteBmp do begin
    { TmpL = Taille de la palette (en octets) }
    if FinEnteteBmp.BitsParPixel<=8 then begin
      { Calcule le nombre de couleur }
      TmpL := FinEnteteBmp.NbrCoulUtile;
      if TmpL=0 then TmpL := 1 shl FinEnteteBmp.BitsParPixel;

      { Calcule la taille de la palette : NbrCoul*4 }
      TmpL := TmpL shl 2;
    end else TmpL := 0;

    Signature := { 'BM' } $4D42;     { Signature BMP = 'BM'= 424Dh           }
    TailleFich := TailleDonnee+SizeOf(DebutEnteteBmp);
                                  { Respectivement : en-tte+palette+donnes }
    Reserve := $00000000;         { Reserv -> toujours gal  00000000h     }
    DebutDonnee := 54 +TmpL;      { Position du fichier ou dbutent          }
                                  { les donnes de l'image                   }
  end;

  { Ecrit les deux enttes }
  BlockWrite (FichTmp, DebutEnteteBmp, SizeOf(DebutEnteteBmp));
  BlockWrite (FichTmp, FinEnteteBmp, SizeOf(FinEnteteBmp));

  { Ecrit les donnes }
  TailleTampon := SizeOf(TamponOct);
  repeat
    { Si on arrive  la fin, calcule la taille du bloc restant }
    if TailleDonnee<PosFich+TailleTampon then TailleTampon := TailleDonnee-PosFich;

    { Lit un bloc }
    BlockRead (F, TamponOct, TailleTampon);

    { Ecrit un bloc }
    BlockWrite (FichTmp, TamponOct, TailleTampon);

    inc (PosFich, TailleTampon);
  until PosFich=TailleDonnee;

  { Ferme le fichier }
  Close (FichTmp);

  {--- Appel le programme d'affichage d'image BMP ---}
  if FichierExistant(NomProgAffiche) then begin
    txt := txt+' '+ParamProgAffiche;

    { Sauve les vecteurs d'interruption }
    SwapVectors;

    { Excute le programme d'affichage }
    Exec (NomProgAffiche,txt);

    { Sauve les erreurs }
    Erreur := DosError;
    CodeSortie := DosExitCode;

    { Remet les vecteurs d'interruption }
    SwapVectors;

    { Erreur d'excution ? Si oui stoppe tout et affiche un message d'erreur }
    if Erreur<>0 then begin
      EcriTcr ('Erreur d''excution du programme d''affichage :',12);
      Ecrit ('> '); EcriTcr (TxtErreurFich(Erreur)+'.',15);
      SauteLigne;
      LitTouche;
    end;

    { Erreur du programme d'affichage ? Si oui attend la pression d'une touche }
    if CodeSortie<>0 then LitTouche;
  end else begin
    { Programme introuvable }
    EffaceEcranTxt;
    EcriTcr ('Le programme d''affichage des images est introuvable !',12);
    SauteLigne;
    Ecrit ('Nom du fichier = '); EcriTcr (NomProgAffiche,15);
    SauteLigne;
    LitTouche;
  end;

  { Dsactive le curseur }
  CurseurOff;

  { Efface le fichier }
{  Erase (FichTmp); {}
end end;

procedure AfficheUnNiveauRes;
var
  OfstCourant: LongInt;
  IndexRes: Word;
begin with ListeRes do begin
  EffaceEcranTxt;

  { Lit l'offset du niveau }
  OfstCourant := OfstNiveau[Niveau];

  { Affiche le dbut du titre }
  CoulTxt := 15+1*16; Ecrit ('[ ');
  if Niveau<>0 then begin
    Ecrit ('Niveau ');
    EcriTnc (Niveau,14+1*16);
  end else Ecrit ('ROOT');

  { Lit l'entte niveau }
  with CopieXms do begin
    Taille := SizeOf(TypeRsrcEnteteNiveau);
    SrcOfs := OfstCourant;
    DstOfs := Ptr2Long( @EnteteNiveau[Niveau] );

    inc (OfstCourant, Taille);
  end;
  CopieMemXms (CopieXms); TestErreurXms ('lecture de l''entte d''un niveau');

  { Affiche la fin du titre }
  Ecrit (' : ');
  EcriTnc (EnteteNiveau[Niveau].NbrEntree,14+1*16);
  EcriTr (' entres ]');
  CoulTxt := 7+0*16;

  { Affiche le rpertoire : retour au niveau -1 }
  if Niveau<>0 then begin
    EcriTc ('\..',CoulResRepos);
    EcriThc (80-EcranX,' ',CoulResRepos);
  end;

  { Traite les entres }
  with EnteteNiveau[Niveau] do begin
    IndexRes := 0;
    while (IndexRes<NbrEntree) do begin
      { Lit une entre }
      with CopieXms do begin
        Taille := SizeOf(TypeRsrcUneEntree);
        SrcOfs := OfstCourant;
        DstOfs := Ptr2Long( @UneEntree );
        inc (OfstCourant, Taille);
      end;
      CopieMemXms (CopieXms); TestErreurXms ('lecture d''une entre');

      with UneEntree do begin
        { Lit le nom de l'entre }
        if NomExiste then begin
          with CopieXmsNom do begin
            Taille := LongNom;
            if Taille and 1=1 then inc(Taille);
            SrcHdl := HandleNom;
            SrcOfs := OfstNom;
            txt[0] := chr(LongNom);
          end;
          CopieMemXms (CopieXmsNom); TestErreurXms ('lecture du nom');
        end else begin
          { Cre un nom }
          if OfstNom<0 then begin
            { C'est une ressource }
            Str (-OfstNom,txt);
            txt := 'Ressource (langage='+txt+')';
          end else begin
            if Niveau<>0 then begin
              { C'est un rpertoire index }
              Str (OfstNom,txt);
              txt := 'ID='+txt;
            { C'est un rpertoire racine (nom=type de ressource) }
            end else txt := PE_NomTypeRessource (OfstNom);
          end;
        end;

        { Affiche une entre }
        if Niveau<>0 then
          if IndexRes=PosListeRes[Niveau]-1 then CoulTxt := CoulResSelect else CoulTxt := CoulResRepos
        else
          if IndexRes=PosListeRes[Niveau] then CoulTxt := CoulResSelect else CoulTxt := CoulResRepos;

        if TypeRepert then Ecrit ('\');
        Ecrit (txt);
        if EcranX<>0 then EcriTh (80-EcranX,' ');
        CoulTxt := 7;
      end;

      inc (IndexRes);
      if 22=IndexRes then begin
        EcriTc ('............. (trop de ressources !!!)',12);
        NbrEntree := 22;
        if Niveau=0 then inc (NbrEntree);
        Exit;
      end;
    end;
  end;
end end;

procedure AfficheUneRessource;
var
  PosDonneeFichier,SauvePosFich: LongInt;
  ModeLectureHexa: Boolean;
  ch: char;
begin with UneRessource do begin
  { Lit l'entte niveau }
  with CopieXms do begin
    Taille := SizeOf(TypeRsrcUneRsrc);
    SrcOfs := UneEntree.Ofst;
    DstOfs := Ptr2Long( @UneRessource );
  end;
  CopieMemXms (CopieXms); TestErreurXms ('lecture d''une ressource');

{$IFNDEF AffichePasDetailRsrc}
  EffaceEcranTxt;

  { Affiche le titre }
  EcriTxcr (-1,0,'[ UNE RESSOURCE ]',15+3*16);
  PosY (4);


  { Affiche les donnes }
  Ecrit ('RVA               = '); EcriTcr (Hex32(OfstDonnee),10);
  Ecrit ('Taille            = '); EcriTnc (TailleDonnee,10);
  Ecrit (' octets ('); EcriTc (Hex32(TailleDonnee),10); EcriTr (')');
  Ecrit ('Langage           = '); EcriTncr (-UneEntree.OfstNom,10);
  Ecrit ('Type de ressource = ');
  if TypeRessourceActuel<>-1 then EcriTcr (NomTypeResActuel,14) else EcriTcr (''''+NomTypeResActuel+'''',12);
  SauteLigne;

  { Affiche les commandes clavier }
  EcriTr ('Quand la ressource sera affiche, tapez une touche pour imposer la lecture');
  EcriTr ('hexadcimal ou echape pour revenir dans la liste des ressources.');
  SauteLigne;
  EcriTc ('Tapez une touche pour afficher la ressource (echape pour revenir) : ',15);
  CurseurOn;
  ch := LitTouche;
  if ch=_ECHAPE then Exit;
{$ENDIF}

  { Calcule l'offset (dans le fichier) de la ressource }
  PosDonneeFichier :=
    OfstRessource +UneRessource.OfstDonnee-PE_EnteteOptionnelPE.Repertoire[3].Rva;

  { Si l'offset est dans le fichier, affiche la ressource }
  if (0<PosDonneeFichier) and (PosDonneeFichier<FileSize(F)) then begin
    if TailleDonnee<>0 then begin
      { Se positionne  l'offset (dans le fichier) de la ressoure }
      SauvePosFich := FilePos(F);
      Seek (F, PosDonneeFichier);

      { La ressource est une image BMP ? }
      if TypeRessourceActuel<>_iTypeResBmp then begin
        EffaceEcranTxt;

        Case TypeRessourceActuel of
        _iTypeResTxt: begin AfficheResTxt; LitTouche end;
        _iTypeResDlg: AfficheResDlg;
        else begin AfficheResHex; LitTouche end;
        end;

      { Type de ressource = Image BMP }
      end else AfficheResBmp;

      { Revient  la position sauvegarde du fichier }
      Seek (F, SauvePosFich);
      ch := #1;
    end else begin
      { Aucune donne : taille nulle ! }
      SauteLigne;
      EcriTcr ('La taille des donnes est nulle !',14+4*16);
      ch := #0;
    end;
  end else begin
    EcriTcr ('Offset incorrect !',14+4*16);
    EcriTr ('(en dehors du fichier)');
    SauteLigne;
    ch := #0;
  end;

  { Lit une touche puis raffiche le niveau }
  if ch=#0 then if LitTouche=_ECHAPE then Fin;
  AfficheUnNiveauRes;
end end;

procedure DeplaceListeRes (Plus: ShortInt); begin with ListeRes do begin
  if Plus=-127 then TmpL := 0
  else if Plus=+127 then begin
    TmpL := EnteteNiveau[Niveau].NbrEntree;
    if Niveau=0 then dec (TmpL);
  end else begin
    { Se dplace relativement }
    TmpL := PosListeRes[Niveau] +Plus;
    if TmpL<0 then TmpL := 0;
    if Niveau=0 then begin
      if EnteteNiveau[Niveau].NbrEntree-1<TmpL then TmpL := EnteteNiveau[Niveau].NbrEntree-1;
    end else begin
      if EnteteNiveau[Niveau].NbrEntree<TmpL then TmpL := EnteteNiveau[Niveau].NbrEntree;
    end;
  end;

  ColoriH (0,1+PosListeRes[Niveau],80,CoulResRepos);
  PosListeRes[Niveau] := TmpL;
  ColoriH (0,1+PosListeRes[Niveau],80,CoulResSelect);
end end;

procedure ChangeNiveauRes (Plus: ShortInt);begin with ListeRes do begin
  if Plus=+1 then begin
    { Si nous somme dans le niveau, sauve le type de ressource }
    if Niveau=0 then with UneEntree do begin
      if NomExiste then begin
      { Le nom du type de ressource existe : le nom }
        with CopieXmsNom do begin
          Taille := LongNom;
          if Taille and 1=1 then inc(Taille);
          SrcHdl := HandleNom;
          SrcOfs := OfstNom;
          txt[0] := chr(LongNom);
        end;
        CopieMemXms (CopieXmsNom); TestErreurXms ('lecture du nom');

        NomTypeResActuel := txt;
        TypeRessourceActuel := -1;
      end else begin
      { Type de ressource de ressource index }
        TypeRessourceActuel := OfstNom;
        NomTypeResActuel := PE_NomTypeRessource (TypeRessourceActuel);
      end;
    end;

    { Change de niveau }
    inc (Niveau);
    OfstNiveau[Niveau] := UneEntree.Ofst;
    if Niveau<>0 then PosListeRes[Niveau] := 1 else PosListeRes[0] := 0;

    { Si le rpertoire contient juste une ressource : l'affiche }
    AfficheUnNiveauRes;
    if (EnteteNiveau[Niveau].NbrEntree=1) and (UneEntree.TypeRepert=FALSE) then begin
      AfficheUneRessource;
      dec (Niveau);
      AfficheUnNiveauRes;
    end;
  end;

  if (Plus=-1) and (Niveau<>0) then begin
    dec (Niveau);
    AfficheUnNiveauRes;
  end;
end end;

procedure AfficheRessources; begin with ListeRes do begin
  { Initialise les structures de copie XMS (passe en lecture) }
  with CopieXms do begin
    SrcHdl := Handle;
    DstHdl := 0;
  end;

  with CopieXmsNom do begin
    SrcHdl := HandleNom;
    DstHdl := 0;
    DstOfs := Ptr2Long( @txt[1] );
  end;

  { Affiche le niveau ROOT }
  Niveau := 0;
  OfstNiveau[0] := 0;
  PosListeRes[0] := 0;
  AfficheUnNiveauRes;

  { Dsactive le curseur }
  CurseurOff;

  { Navigation dans les ressources }
  ch := #0;
  repeat
    ch := UpCase(LitTouche);

    Case ch of
    { Dplacement dans la liste (haut, bas, ...) }
    _Debut:    DeplaceListeRes (-127);
    _PageHaut: DeplaceListeRes (-5);
    _Haut:     DeplaceListeRes (-1);
    _Bas:      DeplaceListeRes (+1);
    _PageBas:  DeplaceListeRes (+5);
    _Fin:      DeplaceListeRes (+127);

    { Entre : Entre dans un rpertoire ou lit une ressource }
    _Entree: begin
      { Lit l'entre slectionne }
      if (Niveau=0) or ((Niveau<>0) and (PosListeRes[Niveau]<>0)) then begin
        with CopieXms do begin
          Taille := SizeOf(TypeRsrcUneEntree);
          if Niveau<>0 then
            SrcOfs := OfstNiveau[Niveau] +SizeOf(TypeRsrcEnteteNiveau) +(PosListeRes[Niveau]-1)*SizeOf(UneEntree)
          else
            SrcOfs := OfstNiveau[Niveau] +SizeOf(TypeRsrcEnteteNiveau) +PosListeRes[Niveau]*SizeOf(UneEntree);
          DstOfs := Ptr2Long( @UneEntree );
        end;
        CopieMemXms (CopieXms); TestErreurXms ('lecture de l''entre selctionne');
      end else UneEntree.TypeRepert := TRUE;

      { L'entre est une ressource ? }
      with UneEntree do begin
        if TypeRepert then begin
          if (Niveau<>0) and (PosListeRes[Niveau]=0) then
            ChangeNiveauRes (-1)
          else
            ChangeNiveauRes (+1);
        end else begin
        { C'est une ressource }
          AfficheUneRessource;
          ChangeNiveauRes (-1);
        end;
      end;
    end end;
  until ch=_ECHAPE;
end end;

procedure AfficheToutesRessources;
var SauvePosFich: LongInt;
begin with ListeRes do begin
  EffaceEcranTxt;

  EcriTcr ('Cration de la liste des ressources en cours ...',15);

  { Sauvegarde la position du fichier }
  SauvePosFich := FilePos(F);

  { Si le rpertoire n'existe pas, on se casse }
  TmpL := ChercheOfstRessource;
  if TmpL=-1 then begin
    EcriTcr ('Section ressource introuvable !',14+4*16);
    SauteLigne;
    LitTouche;
    Exit;
  end else begin
    { Sauve la position des ressources }
    OfstRessource := TmpL;

    { S'y place }
    Seek (F, TmpL);
  end;

  { Cre la liste des ressources }
  CreeListeRessource;

  { Affiche la liste du niveau ROOT }
  AfficheRessources;

  { Revient  la position sauvegarde du fichier }
  Seek (F, SauvePosFich);
end end;

begin
  Init;

  { Entte PE }
  PE_LitEntetePE;
  {$IFNDEF AffichePasInfoPE} AfficheInfoPE; {$ENDIF}
  {$IFNDEF AffichePasRepert} AfficheRepertoire; {$ENDIF}

  { Sections }
  {$IFNDEF AffichePasSection} LitPuisAfficheSections; {$ENDIF}

  { Affiche les ressources }
  {$IFNDEF AffichePasRsrc} AfficheToutesRessources; {$ENDIF}

  { Termine le programme }
  Fin;
end.